"""

DHTMLSpy - Identifying Targeted Sites
Michael Hale Ligh and Greg Sinclair @ iDefense
http://code.google.com/mhl-malware-scripts

"""

from immlib import LogBpHook
import immlib

ProgName="DHTMLSpy"

class MyOwnHook(LogBpHook):

    def __init__(self):
        LogBpHook.__init__(self)

    def run(self,regs):
        imm = immlib.Debugger() 
        param1 = imm.readString(imm.readLong(regs['ESP']+12)) # 3rd argument (lpString1)
        param2 = imm.readString(imm.readLong(regs['ESP']+20)) # 5th argument (lpString2)
        log_items = ["%s" % param1, "%s" % param2]
        dhtml_win = imm.getKnowledge("dhtml_win")
        dhtml_win.add(regs['EIP'], log_items)

def main():
    imm = immlib.Debugger()
    imm.ignoreSingleStep("CONTINUE")

    # Create the packet capture window and add to knowledge base
    column_titles = ["String to compare", "String to match"]
    dhtml_win = imm.createWindow("DHTML Spy Trojan", column_titles )
    imm.addKnowledge("dhtml_win", dhtml_win, force_add=0x1)

    myhooks = MyOwnHook()

	# Hook CompareStringA
    CompareStringA = imm.getAddress("kernel32.CompareStringA")
    myhooks.add("CompareStringA", CompareStringA)
    imm.addKnowledge("%08x" % CompareStringA, "CompareStringA", force_add=0x1)
    imm.Log("%s: Hooked CompareStringA @ 0x%x" % (ProgName, CompareStringA))
        
        
    