"""

KrakenSpy - Kraken Network Traffic Decryption
Michael Hale Ligh and Greg Sinclair @ iDefense
http://code.google.com/mhl-malware-scripts

"""

from immlib import LogBpHook
import immlib

ProgName="KrakenSpy"

class set_hooks(LogBpHook):

	def __init__(self):
		LogBpHook.__init__(self)
    	
	def run(self,regs):
		imm = immlib.Debugger()
        
		eip = imm.readLong(regs['ESP'])              # Figure out where [ESP] points to
		buffptr = imm.readLong(regs['ESP']+4)        # Get the buffer ptr (data buffer)
		bufferSize = imm.readLong(regs['ESP']+8)     # Get the buffer size
		buff = imm.readMemory(buffptr, bufferSize)   # Get the buffer from memory
           
		# decrypt function is called twice. once for the 12 byte header and once for the data
		# so skip the header call 
		if bufferSize > 12:
			column_data = ["%08x" % eip, "%x (%d)" % (bufferSize, bufferSize), "%s" % buff]
			krakendata_win = imm.getKnowledge("krakendata_win")
			krakendata_win.add(regs['EIP'],column_data)

def main():
	imm = immlib.Debugger()
	imm.ignoreSingleStep("CONTINUE")
	hooker = set_hooks()
    
	# Create the packet capture window and add to knowledge base
	column_titles = ["Return Address","Buffer Size","Data"]
	krakendata_win = imm.createWindow("Kraken Network Traffic", column_titles )
	imm.addKnowledge("krakendata_win", krakendata_win,force_add=0x1)
    
	# Start of encryption function in Kraken binary
	funcAddr = 0x00858EFE
	funcName = "wsfdmj.00858EFE"
	hooker.add(funcName,  funcAddr)
	imm.addKnowledge("%08x" %  funcAddr, funcName)
	imm.Log("%s: Added entry for function %s " % (ProgName, funcName))

	return "Kraken Data hooks installed."


