"""

LaqmaSpy - Laqma IPC Snooping
Michael Hale Ligh and Greg Sinclair @ iDefense
http://code.google.com/mhl-malware-scripts

"""

from immlib import LogBpHook
import immlib

ProgName="LaqmaSpy"

class MyOwnHook(LogBpHook):

    def __init__(self):
        LogBpHook.__init__(self)

    def run(self,regs):
        imm = immlib.Debugger()

		# Associate the msgId with the API hook type
        hooks = {0x424: ("HttpSendRequest"),\
                 0x425: ("InternetConnectA"),\
                 0x426: ("HttpOpenRequestA"),}

		# Base address of mapped memory "Global\temp_xchg" (1st argument to FlushViewOfFile)
        mapped  = imm.readLong(regs['ESP']+4) 
		# Size of mapped memory (2nd argument to FlushViewOfFile)
        mapsize = imm.readLong(regs['ESP']+8)
		# Obtain the msgId from the mapped memory
        msgid   = imm.readLong(mapped+4)

        if (msgid in hooks) and (mapsize >= 12):
            hnet = imm.readLong(mapped+8) # Internet handle (track requests)
            hooktype = hooks[msgid]
            data = ""
            if hooks[msgid] == "InternetConnectA":
                data = imm.readString(mapped+12)
            elif (hooks[msgid] == "HttpOpenRequestA") or \
                 (hooks[msgid] == "HttpSendRequest"):
                data = imm.readString(mapped+16)
            log_items = ["0x%x: %s" % (msgid, hooktype), "0x%x" % hnet, "%s" % data]
            laqma_msg_win = imm.getKnowledge("laqma_msg_win")
            laqma_msg_win.add(regs['EIP'], log_items)

def main():
    imm = immlib.Debugger()
    imm.ignoreSingleStep("CONTINUE")

    # Create the packet capture window and add to knowledge base
    column_titles = ["Message Type", "Handle", "Data"]
    laqma_msg_win = imm.createWindow("Laqma Message Queue", column_titles )
    imm.addKnowledge("laqma_msg_win", laqma_msg_win, force_add=0x1)

    myhooks = MyOwnHook()

	# Hook FlushViewOfFile 
    FlushViewOfFile = imm.getAddress("kernel32.FlushViewOfFile")
    myhooks.add("FlushViewOfFile", FlushViewOfFile)
    imm.addKnowledge("%08x" % FlushViewOfFile, "FlushViewOfFile", force_add=0x1)
    imm.Log("%s: Hooked FlushViewOfFile @ 0x%x" % (ProgName, FlushViewOfFile))