"""

SilentBanker_API - Silent Banker API Resolution
Michael Hale Ligh and Greg Sinclair @ iDefense
http://code.google.com/mhl-malware-scripts

"""

import immlib 

def main ():
    imm = immlib.Debugger()
    table = imm.createTable('Silent Banker Import Resolver', ['Offset', 'Name'])
	# Address of the function where all imports are resolved
    FxResolveImports = 0x10005E63
    imm.setBreakpoint(FxResolveImports)
    imm.Run()
	#  A pointer to the base address of call table is passed to the function
    fxtbl = imm.readLong(imm.getRegs()['ESP'])
	# Step over the function so that all imports are resolved by the Trojan
    imm.stepOver() 
    # Iterate the call table entries and do a reverse lookup
    for i in range (1,100):
        addr = imm.readLong( fxtbl + (i*4) )
        if addr:
            func = imm.getFunction(addr)
            name = func.getName()
            table.add('', ["0x%x" % i, "%s" % name])
