"""

SilentBanker_Strings - Silent Banker Strings Decoder
Michael Hale Ligh and Greg Sinclair @ iDefense
http://code.google.com/mhl-malware-scripts

"""

import immlib

def main():
    imm = immlib.Debugger()
    table = imm.createTable('Silent Banker Strings', ['Address', 'Encoded', 'Decoded'])
    decoder_start = 0x100122E8
    ref = imm.getXrefFrom(decoder_start)
    # For each function that calls the decoder function
    for info in ref:
        xref = info[0]
        mov_eax = 0
        addr = 0
        # Disassemble backwards until finding MOV EAX, offset aStringName
        for i in range (1,4):
            op = imm.disasmBackward(xref, i)
            instr = op.getDisasm()
            if "MOV EAX" in instr:
                # Get address of encoded string in memory (.text section)
                addr = op.operand[1][3]
                break
        if addr != 0:
            before = imm.readString(addr)
            # Prepare the stack for the function call 
            imm.setReg('EIP', xref)
            # The input and output buffers can be the same 
            imm.writeLong(imm.getRegs()['ESP'], addr)
            imm.writeLong(imm.getRegs()['ESP']+4, addr)
            imm.stepOver()
            # Now read the result
            after = imm.readString(addr)
            table.add('', ['0x%x' % addr, '%s' % before, '%s' % after])
